# NetworkIDObject Class Reference

Unique shared ids for each object instance. More...

`#include <NetworkIDObject.h>`

Inheritance diagram for NetworkIDObject:

List of all members.

## Public Member Functions
virtual void | SetNetworkIDManager (NetworkIDManager *manager)
virtual NetworkIDManager * | GetNetworkIDManager (void)
| Returns what was passed to SetNetworkIDManager.
virtual NetworkID | GetNetworkID (void)
virtual void | SetNetworkID (NetworkID id)
virtual void | SetParent (void *_parent)
virtual void * | GetParent (void) const
virtual bool | RequiresSetParent (void) const
uint32_t | GetAllocationNumber (void) const
| Used so I can compare pointers in the ReplicaManager.
## Protected Member Functions
void | GenerateID (void)
| Internal function to generate an ID when needed. This is deferred until needed and is not called from the constructor.
## Protected Attributes
NetworkID | networkID
| The network ID of this object.
void * | parent
| The parent set by SetParent().
bool | callGenerationCode
| This is crap but is necessary because virtual functions don't work in the constructor.
## Static Protected Attributes
static uint32_t | nextAllocationNumber
| Used so I can compare pointers in the ReplicaManager.

## Detailed Description

Unique shared ids for each object instance.

A class you can derive from to make it easier to represent every networked object with an integer. This way you can refer to objects over the network. One system should return true for IsNetworkIDAuthority() and the rest should return false. When an object needs to be created, have the the one system create the object. Then have that system send a message to all other systems, and include the value returned from GetNetworkID() in that packet. All other systems should then create the same class of object, and call SetNetworkID() on that class with the NetworkID in the packet.

See also:
  the manual for more information on this.

## Member Function Documentation

virtual NetworkID NetworkIDObject::GetNetworkID | ( | void |  | ) | `[virtual]`

Returns the NetworkID that you can use to refer to this object over the network.

Precondition:
  You must first call SetNetworkIDManager before using this function

Return values:

  | UNASSIGNED_NETWORK_ID | UNASSIGNED_NETWORK_ID is returned IsNetworkIDAuthority() is false and SetNetworkID() was not previously called. This is also returned if you call this function in the constructor.
  | 0-65534 | Any other value is a valid NetworkID. NetworkIDs start at 0 and go to 65534, wrapping at that point.

virtual void* NetworkIDObject::GetParent | ( | void |  | ) | const`[virtual]`

Return what was passed to SetParent

Returns:
  The value passed to SetParent, or 0 if it was never called.

virtual bool NetworkIDObject::RequiresSetParent | ( | void |  | ) | const`[virtual]`

Overload this function and return true if you require that SetParent is called before this object is used. This is a safety check you should do this if you want this to be a member object of another class rather than derive from this class.

virtual void NetworkIDObject::SetNetworkID | ( | NetworkID | id | ) | `[virtual]`

Sets the NetworkID for this instance. Usually this is called by the clients and determined from the servers. However, if you save multiplayer games you would likely use This on load as well.

virtual void NetworkIDObject::SetNetworkIDManager | ( | NetworkIDManager * | manager | ) | `[virtual]`

Sets the manager class from which to request unique network IDs Unlike previous versions, the NetworkIDObject relies on a manager class to provide IDs, rather than using statics, So you can have more than one set of IDs on the same system.

virtual void NetworkIDObject::SetParent | ( | void * | _parent | ) | `[virtual]`

Your class does not have to derive from NetworkIDObject, although that is the easiest way to implement this. If you want this to be a member object of another class, rather than inherit, then call SetParent() with a pointer to the parent class instance. GET_OBJECT_FROM_ID will then return the parent rather than this instance.

The documentation for this class was generated from the following file:

- d:/RakNet-3.x/Source/NetworkIDObject.h